Index: issm/trunk/src/c/solutions/dakota_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/dakota_core.cpp	(revision 13975)
+++ issm/trunk/src/c/solutions/dakota_core.cpp	(revision 13975)
@@ -0,0 +1,127 @@
+/*!\file:  dakota_core.cpp
+ * \brief: wrapper to the Dakota capabilities. qmu fires up Dakota, and registers a Dakota Pluggin
+ * which will be in charge of running the solution sequences repeteadly, to garner statistics. 
+ *
+ * This routine deals with running ISSM and Dakota in library mode. In library mode, Dakota does not 
+ * run as an execuatble. Its capabilities are linked into the ISSM software. ISSM calls dakota routines 
+ * directly from the dakota library. qmu.cpp is the code that is in charge of calling those routines. 
+ *
+ * Dakota has its own way of running in parallel (for embarassingly parallel jobs). We do not want that, 
+ * as ISSM knows exactly how to run "really parallel" jobs that use all CPUS. To bypass Dakota's parallelism, 
+ * we overloaded the constructor for the parallel library (see the Dakota patch in the externalpackages/dakota
+ * directory). This overloaded constructor fires up Dakota serially on CPU 0 only! We take care of broadcasting 
+ * to the other CPUS, hence ISSM is running in parallel, and Dakota serially on CPU0. 
+ *
+ * Now, how does CPU 0 drive all other CPUS to carry out sensitivity analysese? By synchronizing its call to 
+ * our ISSM cores (diagnostic_core, thermal_core, transient_core, etc ...) on CPU 0 with all other CPUS. 
+ * This explains the structure of qmu.cpp, where cpu 0 runs Dakota, the Dakota pluggin fires up DakotaSpawnCore.cpp, 
+ * while the other CPUS are waiting for a broadcast from CPU0, once they get it, they also fire up 
+ * DakotaSpawnCore. In the end, DakotaSpawnCore is fired up on all CPUS, with CPU0 having Dakota inputs, that it will 
+ * broacast to other CPUS. 
+ *
+ * Now, how does dakota call the DakotaSpawnCore routine? The DakotaSpawnCore is embedded into the DakotaPlugin object 
+ * which is derived from the Direct Interface Dakota objct. This is the only way to run Dakota in library 
+ * mode (see their developper guide for more info). Dakota registers the DakotaPlugin object into its own 
+ * database, and calls on the embedded DakotaSpawnCore from CPU0. 
+ *
+ */ 
+
+/*include files: {{{*/
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./solutions.h"
+#include "../shared/shared.h"
+#include "../include/include.h"
+#include "../io/io.h"
+#include "../toolkits/toolkits.h"
+#include "../EnumDefinitions/EnumDefinitions.h"
+#include "../classes/dakota/DakotaPlugin.h"
+
+#ifdef _HAVE_DAKOTA_ //only works if dakota library has been compiled in.
+#include <ParallelLibrary.H>
+#include <ProblemDescDB.H>
+#include <DakotaStrategy.H>
+#include <DakotaModel.H>
+#include <DakotaInterface.H>
+#endif
+/*}}}*/
+
+void dakota_core(FemModel* femmodel){ 
+
+	#ifdef _HAVE_DAKOTA_ //only works if dakota library has been compiled in.
+
+	int                my_rank;
+	char*              dakota_input_file  = NULL;
+	char*              dakota_output_file = NULL;
+	char*              dakota_error_file  = NULL;
+	int                status=0;
+	Dakota::ModelLIter ml_iter;
+	Parameters* parameters                = NULL;
+
+	/*Recover dakota_input_file, dakota_output_file and dakota_error_file, in the parameters dataset in parallel */
+	femmodel->parameters->FindParam(&dakota_input_file,QmuInNameEnum);
+	femmodel->parameters->FindParam(&dakota_output_file,QmuOutNameEnum);
+	femmodel->parameters->FindParam(&dakota_error_file,QmuErrNameEnum);
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
+	if(my_rank==0){
+
+		// Instantiate/initialize the parallel library and problem description
+		// database objects.
+		Dakota::ParallelLibrary parallel_lib("serial"); //use our own ISSM Dakota library mode constructor, which only fires up Dakota on CPU 0. 
+		Dakota::ProblemDescDB problem_db(parallel_lib); 
+
+		// Manage input file parsing, output redirection, and restart processing
+		// without a CommandLineHandler.  This version relies on parsing of an
+		// input file.
+		problem_db.manage_inputs(dakota_input_file);
+		// specify_outputs_restart() is only necessary if specifying non-defaults
+		parallel_lib.specify_outputs_restart(dakota_output_file,dakota_error_file,NULL,NULL);
+
+		// Instantiate the Strategy object (which instantiates all Model and
+		// Iterator objects) using the parsed information in problem_db.
+		Dakota::Strategy selected_strategy(problem_db);
+
+		// convenience function for iterating over models and performing any
+		// interface plug-ins
+		Dakota::ModelList& models = problem_db.model_list();
+
+		for (ml_iter = models.begin(); ml_iter != models.end(); ml_iter++) {
+
+			Dakota::Interface& interface = ml_iter->interface();
+
+			//set DB nodes to the existing Model specification
+			problem_db.set_db_model_nodes(ml_iter->model_id());
+
+			// Serial case: plug in derived Interface object without an analysisComm
+			interface.assign_rep(new SIM::DakotaPlugin(problem_db,(void*)femmodel), false);
+		}
+
+		// Execute the strategy
+		problem_db.lock(); // prevent run-time DB queries
+		selected_strategy.run_strategy();
+
+		//Warn other cpus that we are done running the dakota iterator, by setting the counter to -1:
+		DakotaSpawnCore(NULL,0, NULL,NULL,0,femmodel,-1);
+
+	}
+	else{
+
+		for(;;){
+			if(!DakotaSpawnCore(NULL,0, NULL,NULL,0,femmodel,0))break; //counter came in at -1 on cpu0, bail out.
+		}
+	}
+
+	/*Free ressources:*/
+	xDelete<char>(dakota_input_file);
+	xDelete<char>(dakota_error_file);
+	xDelete<char>(dakota_output_file);
+
+	#endif //#ifdef _HAVE_DAKOTA_
+}
Index: issm/trunk/src/c/solutions/diagnostic_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/diagnostic_core.cpp	(revision 13405)
+++ issm/trunk/src/c/solutions/diagnostic_core.cpp	(revision 13975)
@@ -60,5 +60,5 @@
 
 	if(ishutter){
-			
+
 		if(VerboseSolution()) _pprintLine_("   computing hutter velocities");
 
@@ -68,10 +68,10 @@
 		femmodel->SetCurrentConfiguration(DiagnosticHutterAnalysisEnum);
 		solver_linear(femmodel);
-		
+
 		if (ismacayealpattyn) ResetBoundaryConditions(femmodel,DiagnosticHorizAnalysisEnum);
 	}
 
 	if ((ismacayealpattyn || isl1l2) ^ isstokes){ // ^ = xor
-		
+
 		if(VerboseSolution()) _pprintLine_("   computing velocities");
 		femmodel->SetCurrentConfiguration(DiagnosticHorizAnalysisEnum);
@@ -95,5 +95,4 @@
 	}
 
-
 	if(save_results){
 		if(VerboseSolution()) _pprintLine_("   saving results");
@@ -103,6 +102,8 @@
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,PressureEnum);
 		if(dim==3) InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VzEnum);
-		RequestedOutputsx(femmodel->results,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,requested_outputs,numoutputs);
+		femmodel->RequestedOutputsx(requested_outputs,numoutputs);
 	}
+
+	if(solution_type==DiagnosticSolutionEnum)femmodel->RequestedDependentsx();
 
 	/*Free ressources:*/
Index: issm/trunk/src/c/solutions/issm.cpp
===================================================================
--- issm/trunk/src/c/solutions/issm.cpp	(revision 13405)
+++ issm/trunk/src/c/solutions/issm.cpp	(revision 13975)
@@ -1,252 +1,35 @@
 /*!\file:  issm.cpp
- * \brief: ISSM main parallel program
+ * \brief: ISSM main program
  */ 
 
 #include "../issm.h"
-#include "../include/globals.h"
-#include "../shared/Numerics/adolc_edf.h"
 
 int main(int argc,char **argv){
 
-	/*I/O: */
-	FILE *output_fid       = NULL;
-	FILE *petscoptionsfid  = NULL;
-	bool  waitonlock       = false;
-	bool  dakota_analysis,control_analysis,tao_analysis;
+	/*Initialize exception trapping: */
+	ExceptionTrapBegin();
 
-	/*AD: */
-	bool autodiff=false;
-	size_t   tape_stats[11];
+	/*Initialize environment (MPI, PETSC, MUMPS, etc ...)*/
+	COMM comm_init=EnvironmentInit(argc,argv);
 
-	/*FemModel: */
-	FemModel *femmodel = NULL;
+	/*Initialize femmodel from arguments provided command line: */
+	FemModel *femmodel = new FemModel(argc,argv,comm_init);
 
-	/*configuration: */
-	void (*solutioncore)(FemModel*)=NULL; //core solution function pointer
-	int* analyses=NULL;
-	int  numanalyses;
-	int  solution_type;
+	/*Solve: */
+	femmodel->Solve();
 
-	/*File names*/
-	char *lockfilename   = NULL;
-	char *binfilename    = NULL;
-	char *outbinfilename = NULL;
-	char *petscfilename  = NULL;
-	char *rootpath       = NULL;
+	/*Output results: */
+	femmodel->OutputResults();
 
-	/*time*/
-	IssmPDouble   start, finish;
-	IssmPDouble   start_core, finish_core;
-	IssmPDouble   start_init, finish_init;
-	int      ierr;
-
-	/*profiling*/   
-	bool profiling = false;
-	IssmPDouble Time_start, Flops_start;
-	IssmPDouble Solution_time, Memory_use, Current_flops;
-
-	ISSMBOOT();
-
-	
-	/*Initialize environments: Petsc, MPI, etc...: */
-	#ifdef _HAVE_PETSC_
-	ierr=PetscInitialize(&argc,&argv,(char*)0,"");  
-	if(ierr) _error_("Could not initialize Petsc");
-	#else
-	#ifdef _HAVE_MPI_
-	MPI_Init(&argc,&argv);
-	#endif
-	#endif
-
-	#ifdef _HAVE_MPI_
-	MPI_Barrier(MPI_COMM_WORLD); start=MPI_Wtime();
-	#else
-	start=(IssmPDouble)clock();
-	#endif
-
-	/*Size and rank: */
-	#ifdef _HAVE_MPI_
-	MPI_Comm_rank(MPI_COMM_WORLD,&my_rank);  
-	MPI_Comm_size(MPI_COMM_WORLD,&num_procs); 
-	#endif
-
-	/*First process inputs*/
-	_pprintLine_("");
-	_pprintLine_("Ice Sheet System Model (" << PACKAGE_NAME << ") version " << PACKAGE_VERSION);
-	_pprintLine_("(website: " << PACKAGE_URL << " contact: " << PACKAGE_BUGREPORT << ")");
-	_pprintLine_("");
-	ProcessArguments(&solution_type,&binfilename,&outbinfilename,&petscfilename,&lockfilename,&rootpath,argc,argv);
-
-	/*out of solution_type, figure out types of analyses needed in the femmodel: */
-	AnalysisConfiguration(&analyses,&numanalyses,solution_type);
-
-	/*before we create the model, start the trace on for AD mode: */
-	#ifdef _HAVE_ADOLC_
-	trace_on(1);
-	#endif
-
-	/*Create femmodel, using input file: */
-	#ifdef _HAVE_MPI_
-	MPI_Barrier(MPI_COMM_WORLD); start_init=MPI_Wtime();
-	#else
-	start_init=(IssmPDouble)clock();
-	#endif
-	femmodel=new FemModel(rootpath,binfilename,outbinfilename,solution_type,analyses,numanalyses);
-	
-	/*get type of solution we are going to run: */
-	CorePointerFromSolutionEnum(&solutioncore,femmodel->parameters,solution_type);
-
-	/*Open output file once for all*/
-	output_fid=pfopen(outbinfilename,"wb");
-	femmodel->parameters->SetParam(output_fid,OutputFilePointerEnum);
-
-	/*add petsc options to parameters: */
-	petscoptionsfid=pfopen(petscfilename,"r");
-	ParsePetscOptionsx(femmodel->parameters,petscoptionsfid);
-	pfclose(petscoptionsfid,petscfilename);
-
-	/*get parameters: */
-	femmodel->parameters->FindParam(&waitonlock,SettingsWaitonlockEnum);
-	femmodel->parameters->FindParam(&dakota_analysis,QmuIsdakotaEnum);
-	femmodel->parameters->FindParam(&control_analysis,InversionIscontrolEnum);
-	femmodel->parameters->FindParam(&tao_analysis,InversionTaoEnum);
-	femmodel->parameters->FindParam(&profiling,DebugProfilingEnum); 
-	femmodel->parameters->FindParam(&autodiff,AutodiffIsautodiffEnum);
-
-	#ifdef _HAVE_MPI_
-	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
-	#else
-	finish_init=(IssmPDouble)clock();
-	#endif
-	
-	/*If running AD, then initialize the tape: */
-	#ifdef _HAVE_ADOLC_
-	GenericParam<Adolc_edf> *theAdolcEDF_p=new GenericParam<Adolc_edf>(AdolcParamEnum);
-	theAdolcEDF_p->GetParameterValue().myEDF_for_solverx_p=reg_ext_fct(EDF_for_solverx);
-	femmodel->parameters->AddObject(theAdolcEDF_p);
-	#else
-	if(autodiff) _error_("ISSM was not compiled with ADOLC support, cannot carry out autodiff analysis!");
-	#endif
-
-	_pprintLine_("call computational core:");
-	#ifdef _HAVE_MPI_
-	MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-	#else
-	start_core=(IssmPDouble)clock();
-	#endif
-	
-	if(profiling)ProfilingStart(&Time_start,&Flops_start);
-
-	if(dakota_analysis){
-		#ifdef _HAVE_DAKOTA_
-		Dakotax(femmodel);
-		#else
-		_error_("ISSM was not compiled with dakota support, cannot carry out dakota analysis!");
-		#endif
-	}
-	else if(control_analysis){
-		#ifdef _HAVE_CONTROL_
-		if(tao_analysis)
-		 controltao_core(femmodel);
-		else
-		 control_core(femmodel);
-		#else
-		_error_("ISSM was not compiled with control support, cannot carry out dakota analysis!");
-		#endif
-	}
-	else{
-		solutioncore(femmodel);
-	}
-
-	if(profiling){
-		ProfilingEnd(&Solution_time,&Memory_use,&Current_flops,Time_start,Flops_start);
-		femmodel->results->AddObject(new GenericExternalResult<double>(femmodel->results->Size()+1, ProfilingSolutionTimeEnum, Solution_time, 1, 0));
-		femmodel->results->AddObject(new GenericExternalResult<double>(femmodel->results->Size()+1, ProfilingCurrentMemEnum, Memory_use, 1, 0));
-		femmodel->results->AddObject(new GenericExternalResult<double>(femmodel->results->Size()+1, ProfilingCurrentFlopsEnum, Current_flops, 1, 0));
-	}
-
-	#ifdef _HAVE_ADOLC_
-	if(autodiff){
-		trace_off();
-		AutodiffDriversx(femmodel->elements, femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,femmodel->results);
-	}
-	#endif
-
-
-	#ifdef _HAVE_MPI_
-	MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
-	#else
-	finish_core=(IssmPDouble)clock();
-	#endif
-	
-	_pprintLine_("write results to disk:");
-	OutputResultsx(femmodel->elements, femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,femmodel->results);
-	
-	/*If running AD, close our tape, print statistics: {{{*/
-	#ifdef _HAVE_ADOLC_
-	if(autodiff){
-		tapestats(1,tape_stats); //reading of tape statistics
-		_pprintLine_("   ADOLC statistics: ");
-		_pprintLine_("   "<<setw(45)<<left<<"Number of independents: " <<tape_stats[0]);
-		_pprintLine_("   "<<setw(45)<<left<<"Number of dependents: " <<tape_stats[1]);
-		_pprintLine_("   "<<setw(45)<<left<<"Maximal number of live active variables: " <<tape_stats[2]);
-		_pprintLine_("   "<<setw(45)<<left<<"Size of value stack (number of overwrites): " <<tape_stats[3]);
-		_pprintLine_("   "<<setw(45)<<left<<"Buffer size (a multiple of eight): " <<tape_stats[4]);
-		_pprintLine_("   "<<setw(45)<<left<<"Total number of operations recorded: " <<tape_stats[5]);
-	}
-	#endif  /*}}}*/
-
-	/*Close output and petsc options file and write lock file if requested*/
-	pfclose(output_fid,lockfilename);
-	if (waitonlock>0){
-		_pprintLine_("write lock file:");
-		WriteLockFile(lockfilename);
-	}
-
-	/*Free resources */
-	xDelete<int>(analyses);
-	xDelete<char>(lockfilename);
-	xDelete<char>(binfilename);
-	xDelete<char>(outbinfilename);
-	xDelete<char>(petscfilename);
-	xDelete<char>(rootpath);
+	/*Wrap up: */
 	delete femmodel;
 
-	/*Get finish time and close*/
-	#ifdef _HAVE_MPI_
-	MPI_Barrier(MPI_COMM_WORLD); finish = MPI_Wtime( );
-	_pprintLine_("");
-	_pprintLine_("   "<<setw(40)<<left<<"FemModel initialization elapsed time:"<<finish_init-start_init);
-	_pprintLine_("   "<<setw(40)<<left<<"Core solution elapsed time:"<<finish_core-start_core);
-	_pprintLine_("");
-	_pprintLine_("   Total elapsed time:"<<int((finish-start)/3600)<<" hrs "<<int(int(finish-start)%3600/60)<<" min "<<int(finish-start)%60<<" sec");
-	_pprintLine_("");
-	#else
-	finish=(IssmPDouble)clock();
-	_pprintLine_("");
-	_pprintLine_("   "<<setw(40)<<left<<"FemModel initialization elapsed time:"<<(finish_init-start_init)/CLOCKS_PER_SEC);
-	_pprintLine_("   "<<setw(40)<<left<<"Core solution elapsed time:"<<(finish_core-start_core)/CLOCKS_PER_SEC);
-	_pprintLine_("");
-	_pprintLine_("   Total elapsed time:"
-				<<int((finish-start)/CLOCKS_PER_SEC/3600)<<" hrs "
-				<<int(int(finish-start)/CLOCKS_PER_SEC%3600/60)<<" min "
-				<<int(finish-start)/CLOCKS_PER_SEC%60<<" sec");
-	_pprintLine_("");
-	#endif
-	
-	#ifdef _HAVE_PETSC_
-	_pprintLine_("closing MPI and Petsc");
-	PetscFinalize(); 
-	#else
-	#ifdef _HAVE_MPI_
-	_pprintLine_("closing MPI and Petsc");
-	MPI_Finalize();
-	#endif
-	#endif
+	/*Finalize environment:*/
+	EnvironmentFinalize();
 
-	
-	/*end module: */
-	ISSMEND();
+	/*Finalize exception trapping: */
+	ExceptionTrapEnd();
 
-	return 0; //unix success return;
+	/*Return unix success: */
+	return 0; 
 }
Index: issm/trunk/src/c/solutions/kriging.cpp
===================================================================
--- issm/trunk/src/c/solutions/kriging.cpp	(revision 13405)
+++ issm/trunk/src/c/solutions/kriging.cpp	(revision 13975)
@@ -4,9 +4,11 @@
 
 #include "../issm.h"
-#include "../include/globals.h"
 
 /*Local prototypes*/
 void ProcessArguments2(char** pbinfilename,char** poutbinfilename,char** plockfilename,char** prootpath,int argc,char **argv);
 void ProcessInputfile(IssmDouble **px,IssmDouble **py,IssmDouble **pdata,int *pnobs,IssmDouble **px_interp,IssmDouble **py_interp,int *pninterp,Options **poptions,FILE* fid);
+
+int my_rank;
+int num_procs;
 
 int main(int argc,char **argv){
@@ -23,4 +25,8 @@
 	char *rootpath       = NULL;
 
+	MPI_Comm comm;
+	extern int my_rank;
+	extern int num_procs;
+
 	/*Input*/
 	int         ninterp,nobs;
@@ -36,21 +42,12 @@
 	IssmDouble *error       = NULL;
 
-	ISSMBOOT();
+	/*Initialize exception trapping: */
+	ExceptionTrapBegin();
 
-	/*Initialize environments: Petsc, MPI, etc...: */
-#ifdef _HAVE_PETSC_
-	int ierr=PetscInitialize(&argc,&argv,(char*)0,"");  
-	if(ierr) _error_("Could not initialize Petsc");
-#else
-#ifdef _HAVE_MPI_
-	MPI_Init(&argc,&argv);
-#endif
-#endif
+	/*Initialize environment (MPI, PETSC, MUMPS, etc ...)*/
+	comm=EnvironmentInit(argc,argv);
 
-	/*Size and rank: */
-#ifdef _HAVE_MPI_
-	MPI_Comm_rank(MPI_COMM_WORLD,&my_rank);  
-	MPI_Comm_size(MPI_COMM_WORLD,&num_procs); 
-#endif
+	MPI_Comm_size(comm,&num_procs);
+	MPI_Comm_rank(comm,&my_rank);
 
 	/*First process inputs*/
@@ -76,5 +73,5 @@
 		results->AddObject(new GenericExternalResult<double*>(results->Size()+1,1,error,ninterp,1,1,0));
 		for(int i=0;i<results->Size();i++){
-			ExternalResult* result=(ExternalResult*)results->GetObjectByOffset(i);
+			ExternalResult* result=dynamic_cast<ExternalResult*>(results->GetObjectByOffset(i));
 			result->WriteData(output_fid,1);
 		}
@@ -101,16 +98,9 @@
 	delete results;
 
-#ifdef _HAVE_PETSC_
-	_pprintLine_("closing MPI and Petsc");
-	PetscFinalize(); 
-#else
-#ifdef _HAVE_MPI_
-	_pprintLine_("closing MPI and Petsc");
-	MPI_Finalize();
-#endif
-#endif
+	/*Finalize environment:*/
+	EnvironmentFinalize();
 
-	/*end module: */
-	ISSMEND();
+	/*Finalize exception trapping: */
+	ExceptionTrapEnd();
 
 	return 0; //unix success return;
@@ -166,5 +156,5 @@
 	Option  *option   = NULL;
 
-	int dummy,M,N;
+	int      M,N;
 	IoModel* iomodel = new IoModel();
 	iomodel->fid=fid;
Index: issm/trunk/src/c/solutions/objectivefunction.cpp
===================================================================
--- issm/trunk/src/c/solutions/objectivefunction.cpp	(revision 13405)
+++ issm/trunk/src/c/solutions/objectivefunction.cpp	(revision 13975)
@@ -22,9 +22,7 @@
 IssmDouble objectivefunction(IssmDouble search_scalar,OptArgs* optargs){
 
-	int i;  
-	
 	/*output: */
 	IssmDouble J;
-	
+
 	/*parameters: */
 	int        solution_type,analysis_type;
@@ -70,5 +68,5 @@
 
 	/*Compute misfit for this velocity field.*/
-	CostFunctionx(&J, femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials, femmodel->parameters);
+	femmodel->CostFunctionx(&J);
 
 	/*Free ressources:*/
Index: issm/trunk/src/c/solutions/prognostic_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/prognostic_core.cpp	(revision 13405)
+++ issm/trunk/src/c/solutions/prognostic_core.cpp	(revision 13975)
@@ -17,8 +17,11 @@
 	bool save_results;
 	bool issmbgradients,ispdd,isdelta18o;
+	int  solution_type;
+	int  *requested_outputs = NULL;
+	int  numoutputs=0;
 
 	/*activate formulation: */
 	femmodel->SetCurrentConfiguration(PrognosticAnalysisEnum);
-	
+
 	/*recover parameters: */
 	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
@@ -26,4 +29,7 @@
 	femmodel->parameters->FindParam(&ispdd,SurfaceforcingsIspddEnum);
 	femmodel->parameters->FindParam(&isdelta18o,SurfaceforcingsIsdelta18oEnum);
+	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
+	femmodel->parameters->FindParam(&numoutputs,PrognosticNumRequestedOutputsEnum);
+	if(numoutputs) femmodel->parameters->FindParam(&requested_outputs,&numoutputs,PrognosticRequestedOutputsEnum);
 
 	if(issmbgradients){
@@ -41,8 +47,14 @@
 	if(VerboseSolution()) _pprintLine_("   call computational core");
 	solver_linear(femmodel);
-	
+
 	if(save_results){
 		if(VerboseSolution()) _pprintLine_("   saving results");
 		InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,ThicknessEnum);
+		femmodel->RequestedOutputsx(requested_outputs,numoutputs);
 	}
+
+	if(solution_type==PrognosticSolutionEnum)femmodel->RequestedDependentsx();
+
+	/*Free ressources:*/
+	xDelete<int>(requested_outputs);
 }
Index: issm/trunk/src/c/solutions/solutions.h
===================================================================
--- issm/trunk/src/c/solutions/solutions.h	(revision 13405)
+++ issm/trunk/src/c/solutions/solutions.h	(revision 13975)
@@ -8,4 +8,5 @@
 #include "../classes/objects/objects.h"
 #include "../io/io.h"
+#include "../toolkits/toolkits.h"
 
 struct OptArgs;
@@ -30,4 +31,6 @@
 void steadystate_core(FemModel* femmodel);
 void transient_core(FemModel* femmodel);
+void dakota_core(FemModel* femmodel);
+void ad_core(FemModel* femmodel);
 IssmDouble objectivefunction(IssmDouble search_scalar,OptArgs* optargs);
 
@@ -45,8 +48,13 @@
 void controlrestart(FemModel* femmodel,IssmDouble* J);
 void ResetBoundaryConditions(FemModel* femmodel, int analysis_type);
+COMM EnvironmentInit(int argc,char** argv);
+void EnvironmentFinalize(void);
+int  DakotaSpawnCore(double* responses, int numresponses, double* variables, char** variables_descriptors,int numvariables, void* femmodel,int counter);
+void PrintBanner(void);
 
 //solution configuration
 void AnalysisConfiguration(int** panalyses,int* pnumanalyses, int solutiontype);
 void CorePointerFromSolutionEnum(void (**psolutioncore)(FemModel*),Parameters* parameters,int solutiontype);
+void WrapperCorePointerFromSolutionEnum(void (**psolutioncore)(FemModel*),Parameters* parameters,int solutiontype,bool nodakotacore=false);
 void AdjointCorePointerFromSolutionEnum(void (**padjointcore)(FemModel*),int solutiontype);
 
Index: issm/trunk/src/c/solutions/steadystate_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/steadystate_core.cpp	(revision 13405)
+++ issm/trunk/src/c/solutions/steadystate_core.cpp	(revision 13975)
@@ -29,5 +29,5 @@
 	int  numoutputs         = 0;
 	int  *requested_outputs = NULL;
-	
+
 	/* recover parameters:*/
 	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
@@ -42,5 +42,5 @@
 
 	for(;;){
-	
+
 		if(VerboseSolution()) _pprintLine_("   computing temperature and velocity for step: " << step);
 		#ifdef _HAVE_THERMAL_
@@ -66,5 +66,5 @@
 			break;
 		}
-		
+
 		if(VerboseSolution()) _pprintLine_("   saving velocity, temperature and pressure to check for convergence at next step");
 		InputDuplicatex(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VxEnum,VxPicardEnum);
@@ -73,9 +73,9 @@
 		InputDuplicatex(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,PressureEnum,PressurePicardEnum);
 		InputDuplicatex(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,TemperatureEnum,TemperatureOldEnum);
-		
+
 		//increase counter
 		step++;
 	}
-	
+
 	if(save_results){
 		if(VerboseSolution()) _pprintLine_("   saving results");
@@ -89,5 +89,5 @@
 		if(isenthalpy) InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,EnthalpyEnum);
 		if(!isenthalpy) InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,BasalforcingsMeltingRateEnum);
-		RequestedOutputsx(femmodel->results,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,requested_outputs,numoutputs);
+		femmodel->RequestedOutputsx(requested_outputs,numoutputs);
 	}
 
Index: issm/trunk/src/c/solutions/thermal_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/thermal_core.cpp	(revision 13405)
+++ issm/trunk/src/c/solutions/thermal_core.cpp	(revision 13975)
@@ -16,5 +16,4 @@
 
 	/*intermediary*/
-	IssmDouble melting_offset;
 	bool   save_results;
 	bool   dakota_analysis  = false;
Index: issm/trunk/src/c/solutions/transient_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/transient_core.cpp	(revision 13405)
+++ issm/trunk/src/c/solutions/transient_core.cpp	(revision 13975)
@@ -31,5 +31,5 @@
 	int    numoutputs         = 0;
 	int    *requested_outputs = NULL;
-	
+
 	/*intermediary: */
 	int    step;
@@ -78,5 +78,5 @@
 		/*Increment*/
 		if(time_adapt){
-			TimeAdaptx(&dt,femmodel->elements, femmodel->nodes,femmodel->vertices,femmodel->loads, femmodel->materials, femmodel->parameters); 
+			femmodel->TimeAdaptx(&dt);
 			if(time+dt>finaltime) dt=finaltime-time;
 			femmodel->parameters->SetParam(dt,TimesteppingTimeStepEnum);
@@ -107,5 +107,5 @@
 			#endif
 		}
-		
+
 		if(isdiagnostic){
 			if(VerboseSolution()) _pprintLine_("   computing new velocity");
@@ -121,5 +121,5 @@
 			prognostic_core(femmodel);
 			if(VerboseSolution()) _pprintLine_("   updating vertices positions");
-			UpdateVertexPositionsx(femmodel->elements, femmodel->nodes,femmodel->vertices,femmodel->loads, femmodel->materials, femmodel->parameters); 
+			femmodel->UpdateVertexPositionsx();
 		}
 
@@ -140,5 +140,5 @@
 			InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,SurfaceforcingsMassBalanceEnum);
 			InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,MaskElementonfloatingiceEnum);
-			RequestedOutputsx(femmodel->results,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,requested_outputs,numoutputs);
+			femmodel->RequestedOutputsx(requested_outputs,numoutputs);
 
 			if(isdelta18o){
@@ -152,6 +152,6 @@
 	}
 
-	RequestedDependentsx(femmodel->results,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
-	
+	femmodel->RequestedDependentsx();
+
 	/*Free ressources:*/
 	xDelete<int>(requested_outputs);
Index: issm/trunk/src/c/solvers/solver_adjoint_linear.cpp
===================================================================
--- issm/trunk/src/c/solvers/solver_adjoint_linear.cpp	(revision 13405)
+++ issm/trunk/src/c/solvers/solver_adjoint_linear.cpp	(revision 13975)
@@ -24,7 +24,7 @@
 	/*Recover parameters: */
 	femmodel->parameters->FindParam(&configuration_type,ConfigurationTypeEnum);
-	UpdateConstraintsx(femmodel->nodes,femmodel->constraints,femmodel->parameters);
+	femmodel->UpdateConstraintsx();
 
-	SystemMatricesx(&Kff, &Kfs, &pf, &df, NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
+	femmodel->SystemMatricesx(&Kff, &Kfs, &pf, &df, NULL);
 	CreateNodalConstraintsx(&ys,femmodel->nodes,configuration_type);
 	Reduceloadx(pf, Kfs, ys,true); xdelete(&Kfs); //true means spc = 0
Index: issm/trunk/src/c/solvers/solver_linear.cpp
===================================================================
--- issm/trunk/src/c/solvers/solver_linear.cpp	(revision 13405)
+++ issm/trunk/src/c/solvers/solver_linear.cpp	(revision 13975)
@@ -22,7 +22,7 @@
 	/*Recover parameters: */
 	femmodel->parameters->FindParam(&configuration_type,ConfigurationTypeEnum);
-	UpdateConstraintsx(femmodel->nodes,femmodel->constraints,femmodel->parameters);
+	femmodel->UpdateConstraintsx();
 
-	SystemMatricesx(&Kff, &Kfs, &pf, &df, NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
+	femmodel->SystemMatricesx(&Kff, &Kfs, &pf, &df, NULL);
 	CreateNodalConstraintsx(&ys,femmodel->nodes,configuration_type);
 	Reduceloadx(pf, Kfs, ys); xdelete(&Kfs);
Index: issm/trunk/src/c/solvers/solver_newton.cpp
===================================================================
--- issm/trunk/src/c/solvers/solver_newton.cpp	(revision 13405)
+++ issm/trunk/src/c/solvers/solver_newton.cpp	(revision 13975)
@@ -15,5 +15,4 @@
 	/*intermediary: */
 	bool   converged;
-	int    num_unstable_constraints;
 	int    count;
 	IssmDouble kmax;
@@ -38,5 +37,5 @@
 	femmodel->parameters->FindParam(&max_nonlinear_iterations,DiagnosticMaxiterEnum);
 	femmodel->parameters->FindParam(&configuration_type,ConfigurationTypeEnum);
-	UpdateConstraintsx(femmodel->nodes,femmodel->constraints,femmodel->parameters);
+	femmodel->UpdateConstraintsx();
 
 	count=1;
@@ -57,5 +56,5 @@
 
 		/*Solver forward model*/
-		SystemMatricesx(&Kff,&Kfs,&pf,&df,NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
+		femmodel->SystemMatricesx(&Kff, &Kfs, &pf, &df, NULL);
 		CreateNodalConstraintsx(&ys,femmodel->nodes,configuration_type);
 		Reduceloadx(pf,Kfs,ys);xdelete(&Kfs);
@@ -84,5 +83,5 @@
 
 		/*Prepare next iteration using Newton's method*/
-		SystemMatricesx(&Kff,&Kfs,&pf,NULL,&kmax,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
+		femmodel->SystemMatricesx(&Kff, &Kfs, &pf, &df, NULL);
 		CreateNodalConstraintsx(&ys,femmodel->nodes,configuration_type);
 		Reduceloadx(pf,Kfs,ys);   xdelete(&Kfs);
@@ -91,5 +90,5 @@
 		pJf->Scale(-1.0); pJf->AXPY(pf,+1.0);     xdelete(&pf);
 
-		CreateJacobianMatrixx(&Jff,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,kmax);
+		femmodel->CreateJacobianMatrixx(&Jff,kmax);
 		Solverx(&duf,Jff,pJf,NULL,NULL,femmodel->parameters); xdelete(&Jff); xdelete(&pJf);
 		uf->AXPY(duf, 1.0); xdelete(&duf);
